import gtk


class About_Dialog:
    def delete_event(self,widget,event,data=None):
        return False

    def destroy(self,widget,event):
        self.dialog.destroy()

    def show(self):
        self.dialog.show_all()

    def __init__(self,NUMBER):
        self.dialog=gtk.Dialog(_("About"),None,0,(gtk.STOCK_OK,gtk.RESPONSE_OK))
        self.dialog.set_default_size(300,280)
        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.connect("response",self.destroy)
        self.dialog.set_has_separator(True)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        self.image=gtk.Image()
        self.image.set_from_file("pixmaps/xpn-logo.png")
        self.dialog.vbox.pack_start(self.image,True,True)
        string="<span size='x-large' weight='heavy'>X Python Newsreader %s</span>\n<span weight='heavy' style='italic'>Italian Style</span>\n\nWritten by Antonio 'Nemesis' Caputo\nxpn@altervista.org\n\nhttp://xpn.altervista.org" % (NUMBER,)
        self.label=gtk.Label(string)
        self.label.set_use_markup(True)
        self.label.set_justify(gtk.JUSTIFY_CENTER)
        self.dialog.vbox.pack_start(self.label,True,True,8)

class Dialog_YES_NO:

    def delete_event(self,widget,event,data=None):
        return False

    def __init__(self,message):
        self.resp=""
        self.dialog=gtk.MessageDialog(None,0,gtk.MESSAGE_QUESTION,gtk.BUTTONS_YES_NO,message)
        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        self.dialog.label.set_use_markup(True)
        resp=self.dialog.run()
        if resp==gtk.RESPONSE_YES:
            self.resp=True
        else:
            self.resp=False
        self.dialog.destroy()

class Dialog_OK:

    def delete_event(self,widget,event,data=None):
        return False

    def __init__(self,message):
        self.resp=""
        self.dialog=gtk.MessageDialog(None,0,gtk.MESSAGE_INFO,gtk.BUTTONS_OK,message)
        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        self.dialog.label.set_use_markup(True)
        self.resp=self.dialog.run()
        self.dialog.destroy()


class Error_Dialog(gtk.Dialog):
    def __init__(self,string,log):
        gtk.Dialog.__init__(self,_("Error Dialog"),None,0,(gtk.STOCK_OK,gtk.RESPONSE_OK))
        self.set_default_size(350,350)
        self.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/dialog-error.xpm"))
        self.set_has_separator(True)
        self.set_position(gtk.WIN_POS_CENTER)
        self.buffer=gtk.TextBuffer()
        self.buffer.set_text(string)
        self.view=gtk.TextView(self.buffer)
        self.view.set_wrap_mode(gtk.WRAP_WORD)
        self.view.set_cursor_visible(False)
        self.view.set_border_width(5)
        self.view.set_editable(False)
        self.scrolled_win=gtk.ScrolledWindow()
        self.scrolled_win.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.scrolled_win.set_shadow_type(gtk.SHADOW_OUT)
        self.scrolled_win.add(self.view)
        self.buffer_log=gtk.TextBuffer()
        self.buffer_log.set_text(log)
        self.view_log=gtk.TextView(self.buffer_log)
        self.view_log.set_wrap_mode(gtk.WRAP_WORD)
        self.view_log.set_cursor_visible(False)
        self.view_log.set_border_width(5)
        self.view_log.set_editable(False)
        self.scrolled_win_log=gtk.ScrolledWindow()
        self.scrolled_win_log.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.scrolled_win_log.set_shadow_type(gtk.SHADOW_OUT)
        self.scrolled_win_log.add(self.view_log)
        self.notebook=gtk.Notebook()
        self.label_error=gtk.Label(_("<b>Last Error</b>"))
        self.label_error.set_use_markup(True)
        self.label_error_log=gtk.Label(_("<b>Errors Log</b>"))
        self.label_error_log.set_use_markup(True)
        self.notebook.append_page(self.scrolled_win,self.label_error)
        self.notebook.append_page(self.scrolled_win_log,self.label_error_log)

        self.notebook.show_all()

        self.vbox.pack_start(self.notebook,True,True,0)

class MidDialog(gtk.Dialog):
    def __init__(self,mid):
        gtk.Dialog.__init__(self,_("Message-ID Search Dialog"),None,0,(gtk.STOCK_OK,gtk.RESPONSE_OK,gtk.STOCK_CLOSE,gtk.RESPONSE_CLOSE))

        self.label=gtk.Label(_("<b>Message-ID to search</b>"))
        self.label.set_use_markup(True)
        self.entry=gtk.Entry()
        self.entry.set_text(mid)
        self.entry.show()
        self.label.show()
        self.vbox.pack_start(self.label,True,True)
        self.vbox.pack_start(self.entry,True,True)
        self.r1=gtk.RadioButton(None,_("Search in current group"))
        self.r2=gtk.RadioButton(self.r1,_("Search in subscribed groups"))
        self.r3=gtk.RadioButton(self.r1,_("Search on Google"))
        self.r1.show()
        self.r2.show()
        self.r3.show()
        self.vbox.pack_start(self.r1,True,True)
        self.vbox.pack_start(self.r2,True,True)
        self.vbox.pack_start(self.r3,True,True)
        self.set_size_request(350,200)

        self.resp=self.run()
        self.sel=self.r1.get_active(),self.r2.get_active(),self.r3.get_active()
        self.destroy()
