import gtk


class XPNMenuBar:
    def show(self):
        self.menubar.show_all()

    def get_widget(self):
        return self.menubar

    def insert_separator(self,menu):
        separator=gtk.SeparatorMenuItem()
        menu.append(separator)

    def insert_menu_item(self,menu,name,image_name,accel_group,accel_key,modifier):
        menuitem=gtk.ImageMenuItem(name)
        image=gtk.Image()
        image.set_from_file("pixmaps/"+image_name)
        menuitem.set_image(image)
        menu.append(menuitem)
        menuitem.set_border_width(2)
        if accel_key:
            if not modifier: modifier=0
            a_key=gtk.gdk.keyval_from_name(accel_key)
            if a_key==0: a_key=ord(accel_key)
            menuitem.add_accelerator("activate",accel_group,a_key, modifier, gtk.ACCEL_VISIBLE)
        return menuitem

    def insert_check_menu_item(self,menu,name,accel_group,accel_key,modifier):
        menuitem=gtk.CheckMenuItem(name)
        menuitem.set_active(False)
        menu.append(menuitem)
        menuitem.set_border_width(2)
        if accel_key:
            if not modifier: modifier=0
            menuitem.add_accelerator("activate",accel_group,ord(accel_key), modifier, gtk.ACCEL_VISIBLE)
        return menuitem

    def get_menuitems(self):
        return self.menuitems

    def __init__(self,window):
        #menubar
        self.menubar= gtk.MenuBar()
    
class MainMenuBar(XPNMenuBar):
    def __init__(self,window):
        #menu File
        XPNMenuBar.__init__(self,window)
        menu_file=gtk.Menu()

        menuitem_file=gtk.MenuItem(_("_File"))
        accel_group=gtk.AccelGroup()
        window.add_accel_group(accel_group)
        self.menuitems={}
        self.menuitems["groups"]=self.insert_menu_item(menu_file,_("_Groups List..."),"groups.xpm",accel_group,"G",gtk.gdk.CONTROL_MASK)
        self.insert_separator(menu_file)
        self.menuitems["rules"]=self.insert_menu_item(menu_file,_("_Scoring Rules..."),"score.xpm",accel_group,"S",gtk.gdk.MOD1_MASK)
        self.insert_separator(menu_file)
        self.menuitems["logs"]=self.insert_menu_item(menu_file,_("Server _Logs..."),"white.xpm",accel_group,"L",gtk.gdk.MOD1_MASK)
        self.insert_separator(menu_file)
        self.menuitems["exp_newsrc"]=self.insert_menu_item(menu_file,_("Export _Newsrc..."),"white.xpm",None,None,False)
        self.menuitems["imp_newsrc"]=self.insert_menu_item(menu_file,_("_Import Newsrc..."),"white.xpm",None,None,False)
        self.insert_separator(menu_file)
        self.menuitems["conf"]=self.insert_menu_item(menu_file,_("_Preferences..."),"conf.xpm",accel_group,"P",gtk.gdk.MOD1_MASK)
        self.insert_separator(menu_file)
        self.menuitems["exit"]=self.insert_menu_item(menu_file,_("_Exit"),"exit.xpm",accel_group,"E",gtk.gdk.CONTROL_MASK)

        menuitem_file.set_submenu(menu_file)
        self.menubar.add(menuitem_file)

        #menu Subscribed Groups
        menu_subscribed=gtk.Menu()
        menuitem_groups=gtk.MenuItem(_("Subscribed _Groups"))
        self.menuitems["gethdrs"]=self.insert_menu_item(menu_subscribed,_("_Get New Headers in Subscribed Groups"),"receive_headers.xpm",accel_group,"H",gtk.gdk.CONTROL_MASK)
        self.menuitems["gethdrssel"]=self.insert_menu_item(menu_subscribed,_("_Get New Headers in Selected Groups"),"receive_headers_selected.xpm",accel_group,"H",gtk.gdk.CONTROL_MASK|gtk.gdk.SHIFT_MASK)

        self.menuitems["getbodies"]=self.insert_menu_item(menu_subscribed,_("Get Marked Article _Bodies in Subscribed Groups"),"receive_bodies.xpm",accel_group,"B",gtk.gdk.CONTROL_MASK)
        self.menuitems["getbodiessel"]=self.insert_menu_item(menu_subscribed,_("Get Marked Article _Bodies in Selected Groups"),"receive_bodies_selected.xpm",accel_group,"B",gtk.gdk.CONTROL_MASK|gtk.gdk.SHIFT_MASK)
        self.insert_separator(menu_subscribed)
        self.menuitems["expand"]=self.insert_menu_item(menu_subscribed,_("_Expand All Threads"),"expand.xpm",None,None,False)
        self.menuitems["collapse"]=self.insert_menu_item(menu_subscribed,_("_Collapse All Threads"),"collapse.xpm",None,None,False)
        self.insert_separator(menu_subscribed)
        self.menuitems["mark"]=self.insert_menu_item(menu_subscribed,_("_Mark Selected Groups as Read"),"mark.xpm",None,None,False)
        self.menuitems["markall"]=self.insert_menu_item(menu_subscribed,_("Mark _All Groups as Read"),"mark_all.xpm",None,None,False)
        self.insert_separator(menu_subscribed)
        self.menuitems["group"]=self.insert_menu_item(menu_subscribed,_("_View Next Group"),"white.xpm",accel_group,"G",False)
        self.insert_separator(menu_subscribed)

        submenu_view=gtk.Menu()
        self.menuitems["view_groups_opts"]=self.insert_menu_item(menu_subscribed,_("View Options"),"white.xpm",None,None,False)

        self.menuitems["show_threads"]=self.insert_check_menu_item(submenu_view,_("_Show Threads"),accel_group,"T",gtk.gdk.SHIFT_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["show_read_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Read Articles"),accel_group,"R",gtk.gdk.SHIFT_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["show_unread_articles"]=self.insert_check_menu_item(submenu_view,_("_Show UnRead Articles"),accel_group,"R",gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK)
        self.menuitems["show_kept_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Kept Articles"),accel_group,"K",gtk.gdk.SHIFT_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["show_unkept_articles"]=self.insert_check_menu_item(submenu_view,_("_Show UnKept Articles"),accel_group,"K",gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK)
        self.menuitems["show_watched_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Watched Articles"),accel_group,"W",gtk.gdk.SHIFT_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["show_ignored_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Ignored Articles"),accel_group,"I",gtk.gdk.SHIFT_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["show_unwatchedignored_articles"]=self.insert_check_menu_item(submenu_view,_("_Show UnWatched/UnIgnored Articles"),accel_group,"W",gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK)
        self.menuitems["show_score_neg_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Articles with Score<0"),accel_group,"S",gtk.gdk.SHIFT_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["show_score_zero_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Articles with Score=0"),accel_group,"S",gtk.gdk.MOD1_MASK|gtk.gdk.CONTROL_MASK)
        self.menuitems["show_score_pos_articles"]=self.insert_check_menu_item(submenu_view,_("_Show Articles with Score>0"),accel_group,"S",gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK)
        
        self.menuitems["view_groups_opts"].set_submenu(submenu_view)
        self.insert_separator(menu_subscribed)
        
        self.menuitems["find"]=self.insert_menu_item(menu_subscribed,_("_Find Article..."),"find.xpm",accel_group,"F",gtk.gdk.SHIFT_MASK)
        self.menuitems["global"]=self.insert_menu_item(menu_subscribed,_("Global _Search ..."),"global_search.xpm",accel_group,"G",gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK)

        menuitem_groups.set_submenu(menu_subscribed)
        self.menubar.add(menuitem_groups)

        #menuitem Articles
        menu_articles=gtk.Menu()
        menuitem_articles=gtk.MenuItem(_("_Articles"))
        self.menuitems["previous"]=self.insert_menu_item(menu_articles,_("Read Previous Article"),"previous.xpm",accel_group,"B",False)
        self.menuitems["next"]=self.insert_menu_item(menu_articles,_("Read Next Article"),"next.xpm",accel_group,"N",gtk.gdk.MOD1_MASK)
        self.menuitems["next_unread"]=self.insert_menu_item(menu_articles,_("Read _Next Unread Article"),"next_unread.xpm",accel_group,"N",False)
        self.menuitems["parent"]=self.insert_menu_item(menu_articles,_("Read Parent Article"),"white.xpm",accel_group,"U",False)
        self.menuitems["one_key"]=self.insert_menu_item(menu_articles,_("One-Key Reading"),"white.xpm",accel_group," ",False)
        self.insert_separator(menu_articles)
        self.menuitems["search"]=self.insert_menu_item(menu_articles,_("_Search in the Body..."),"search.xpm",accel_group,"S",gtk.gdk.SHIFT_MASK)
        self.insert_separator(menu_articles)
        submenu_view=gtk.Menu()
        self.menuitems["view_articles_opts"]=self.insert_menu_item(menu_articles,_("View Options"),"white.xpm",None,None,False)
        self.menuitems["raw"]=self.insert_check_menu_item(submenu_view,_("_View Raw Article"),accel_group,"H",False)
        self.menuitems["rot13"]=self.insert_menu_item(submenu_view,_("_ROT13 Selected Text"),"rot13.xpm",accel_group,"R",gtk.gdk.CONTROL_MASK)
        self.menuitems["spoiler"]=self.insert_check_menu_item(submenu_view,_("Show Spoilered Text"),accel_group,"L",gtk.gdk.CONTROL_MASK)
        self.menuitems["show_quote"]=self.insert_check_menu_item(submenu_view,_("Show Quoted Text"),accel_group,"Q",gtk.gdk.CONTROL_MASK)
        self.menuitems["show_sign"]=self.insert_check_menu_item(submenu_view,_("Show Signatures"),accel_group,"S",gtk.gdk.CONTROL_MASK)
        self.menuitems["fixed"]=self.insert_check_menu_item(submenu_view,_("Fixed Pitch Font"),accel_group,"F",gtk.gdk.CONTROL_MASK)
        self.menuitems["show_hide_headers"]=self.insert_menu_item(submenu_view,_("Show/Hide _Headers"),"white.xpm",accel_group,"H",gtk.gdk.MOD1_MASK)
        self.menuitems["view_articles_opts"].set_submenu(submenu_view)
        self.insert_separator(menu_articles)

        submenu_flags=gtk.Menu()
        self.menuitems["flags"]=self.insert_menu_item(menu_articles,_("Flags & Score"),"white.xpm",None,None,False)
        self.menuitems["mark_read"]=self.insert_menu_item(submenu_flags,_("Mark Article as Read"),"art_read.xpm",accel_group,"R",gtk.gdk.SHIFT_MASK)
        self.menuitems["mark_unread"]=self.insert_menu_item(submenu_flags,_("Mark Article as UnRead"),"art_unread.xpm",accel_group,"U",gtk.gdk.SHIFT_MASK)
        self.menuitems["mark_download"]=self.insert_menu_item(submenu_flags,_("Mark Article for Retrieving"),"art_mark.xpm",accel_group,"M",False)
        self.menuitems["keep"]=self.insert_menu_item(submenu_flags,_("Keep Article"),"art_keep.xpm",accel_group,"K",gtk.gdk.SHIFT_MASK)
        self.insert_separator(submenu_flags)
        self.menuitems["watch"]=self.insert_menu_item(submenu_flags,_("Watch SubThread"),"art_watch.xpm",accel_group,"W",gtk.gdk.SHIFT_MASK)
        self.menuitems["ignore"]=self.insert_menu_item(submenu_flags,_("Ignore SubThread"),"art_ignore.xpm",accel_group,"I",gtk.gdk.SHIFT_MASK)
        self.menuitems["mark_download_sub"]=self.insert_menu_item(submenu_flags,_("Mark SubThread for Retrieving"),"mark_multiple.xpm",accel_group,"M",gtk.gdk.CONTROL_MASK)
        self.menuitems["mark_download_group"]=self.insert_menu_item(submenu_flags,_("Mark Group for Retrieving"),"mark_multiple.xpm",accel_group,"M",gtk.gdk.CONTROL_MASK|gtk.gdk.SHIFT_MASK)

        self.insert_separator(submenu_flags)
        self.menuitems["raise_score"]=self.insert_menu_item(submenu_flags,_("Raise Author Score"),"raise_score.xpm",accel_group,"R",gtk.gdk.CONTROL_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["lower_score"]=self.insert_menu_item(submenu_flags,_("Lower Author Score"),"lower_score.xpm",accel_group,"L",gtk.gdk.CONTROL_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["set_score"]=self.insert_menu_item(submenu_flags,_("Set Author Score"),"set_score.xpm",accel_group,"S",gtk.gdk.CONTROL_MASK|gtk.gdk.MOD1_MASK)
        self.menuitems["flags"].set_submenu(submenu_flags)
        self.insert_separator(menu_articles)
        self.menuitems["post"]=self.insert_menu_item(menu_articles,_("_Post New Article..."),"post.xpm",accel_group,"P",False)
        self.menuitems["followup"]=self.insert_menu_item(menu_articles,_("_Follow-Up To Newsgroup..."),"followup.xpm",accel_group,"F",False)
        self.menuitems["reply"]=self.insert_menu_item(menu_articles,_("Reply By _Mail..."),"reply.xpm",accel_group,"M",gtk.gdk.SHIFT_MASK)
        self.menuitems["outbox_manager"]=self.insert_menu_item(menu_articles,_("_Open Outbox Manager"),"outbox.xpm",accel_group,"O",gtk.gdk.SHIFT_MASK)
        self.insert_separator(menu_articles)
        self.menuitems["cancel"]=self.insert_menu_item(menu_articles,_("Cancel Article..."),"cancel.xpm",None,None,False)
        self.menuitems["supersede"]=self.insert_menu_item(menu_articles,_("Supersede Article..."),"supersede.xpm",None,None,False)


        menuitem_articles.set_submenu(menu_articles)

        self.submenu_flags=submenu_flags
        self.menubar.add(menuitem_articles)

        #menuitem Help
        menu_help=gtk.Menu()
        menuitem_help=gtk.MenuItem(_("Help"))
        self.menuitems["about"]=self.insert_menu_item(menu_help,_("_About..."),"about.xpm",None,None,False)
        menuitem_help.set_submenu(menu_help)
        self.menubar.add(menuitem_help)

class EditMenuBar(XPNMenuBar):
    def __init__(self,window):
        XPNMenuBar.__init__(self,window)

        #menu File
        menu_article=gtk.Menu()

        menuitem_article=gtk.MenuItem(_("_Article"))
        accel_group=gtk.AccelGroup()
        window.add_accel_group(accel_group)
        self.menuitems={}
        self.menuitems["send"]=self.insert_menu_item(menu_article,_("_Send Article"),"send.xpm",accel_group,"S",gtk.gdk.CONTROL_MASK)
        self.menuitems["send_later"]=self.insert_menu_item(menu_article,_("Send Article _Later"),"send_queue.xpm",accel_group,"S",gtk.gdk.CONTROL_MASK|gtk.gdk.SHIFT_MASK)
        self.menuitems["save_draft"]=self.insert_menu_item(menu_article,_("Save Article as Draft"),"save.xpm",accel_group,"D",gtk.gdk.MOD1_MASK)
        self.insert_separator(menu_article)
        self.menuitems["discard"]=self.insert_menu_item(menu_article,_("_Discard Article"),"discard.xpm",accel_group,"D",gtk.gdk.CONTROL_MASK)
        self.insert_separator(menu_article)
        self.menuitems["rot13"]=self.insert_menu_item(menu_article,_("_Rot13 Selected Text"),"rot13.xpm",accel_group,"R",gtk.gdk.CONTROL_MASK)
        self.menuitems["spoiler"]=self.insert_menu_item(menu_article,_("_Insert Spoiler Char"),"spoiler_char.xpm",accel_group,"L",gtk.gdk.CONTROL_MASK)

        self.insert_separator(menu_article)
        self.menuitems["editor"]=self.insert_menu_item(menu_article,_("Launch External _Editor"),"editor.xpm",accel_group,"E",gtk.gdk.MOD1_MASK)
        menuitem_article.set_submenu(menu_article)
        self.menubar.add(menuitem_article)


class OutboxMenuBar(XPNMenuBar):
    def __init__(self,window):
        XPNMenuBar.__init__(self,window)

        #menu File
        menu_outbox=gtk.Menu()

        menuitem_outbox=gtk.MenuItem(_("_Outbox"))
        accel_group=gtk.AccelGroup()
        window.add_accel_group(accel_group)
        self.menuitems={}
        self.menuitems["send_article"]=self.insert_menu_item(menu_outbox,_("_Send Queued Articles"),"send_queued_art.xpm",accel_group,"S",gtk.gdk.CONTROL_MASK)
        self.menuitems["send_mail"]=self.insert_menu_item(menu_outbox,_("Send Queued _Mails"),"send_queued_mail.xpm",accel_group,"S",gtk.gdk.CONTROL_MASK|gtk.gdk.SHIFT_MASK)
        self.insert_separator(menu_outbox)
        self.menuitems["edit"]=self.insert_menu_item(menu_outbox,_("_Edit Article/Mail"),"post.xpm",accel_group,"E",False)
        self.menuitems["delete"]=self.insert_menu_item(menu_outbox,_("_Delete Article/Mail"),"delete.xpm",accel_group,"Delete",False)
        self.insert_separator(menu_outbox)
        self.menuitems["exit"]=self.insert_menu_item(menu_outbox,_("_Exit"),"exit.xpm",accel_group,"E",gtk.gdk.CONTROL_MASK)

        menuitem_outbox.set_submenu(menu_outbox)
        self.menubar.add(menuitem_outbox)
    
